* Individualisation des fichiers revenus 


foreach num of global yearliste {
	global year=`num'
	/*local supp=1
	if ($year<=1984) { 
		local supp=2
	}

forval loop=1/`supp' {
	if `loop'==1 {
		use "$wfrev/rev${year}.dta",clear
	}
	if `loop'==2 {
		use "$wfrev/rev${year}avtretraitement.dta",clear
	}
	*/
	use "$wfrev/rev${year}.dta",clear
	* Ajout de defnonsal au niveau foyer
		gen defnonsal_irpp_foy=defnonsal_irpp+defnonsal_irpp_conj+defnonsal_irpp_pac

	* parfois date de naissance du conjoint n'est pas report alors qu'il dispose d'un revenu
		replace ndecl=2 if (sal_irpp_conj+chom_irpp_conj+pension_irpp_conj+nonsal_conj >0) & ndecl==1
		replace agec=age if ndecl==2 & agec==.
		sort idfoy
		
		
	* Table au niveau individuel
			gen ntot=ndecl+npac
			expand ntot if ntot>1
			sort idfoy
					
			* Identifiant
				gen a=1
				bys idfoy: gen idnum=sum(a)
				gen idindiv=sum(a)
				drop a
				gen conj=0
				replace conj=1 if ndecl==2 & idnum==2
				gen pac=1
				replace pac=0 if idnum<=ndecl
							
			* age du conjoint
				gen temp=age
				replace age=agec if conj==1
				replace agec=temp if conj==1
				replace agec=. if pac==1
				drop temp
			
			* age des pac
				if ($year>1970 & $year~=1984) {
					quiet sum npac
					local max=`r(max)'+1
					quiet sum ntot
					forval i=2/`r(max)' {
						local j=`i'-1
						local h=`i'-2
						if `i'<=`max'{
							replace age=anaispac_`j' if idnum==`i' & ndecl==1 & pac==1
						}
						if `i'>2 {
							replace age=anaispac_`h' if idnum==`i' & ndecl==2 & pac==1
						}
					}
				}
						
				bys idfoy : egen npac_m20=sum((age<20)*(pac==1))
					
			* sexe du conjoint
				replace sexe=1 if conj==1 & sexe==2 
				replace sexe=2 if conj==1 & sexe==1 
			* sexe pour les pac : imputation alatoire
				set seed 198983620
				replace sexe=round(runiform())+1 if pac==1
				
		
			* Ajustement des revenus du travail
						
					foreach var of varlist sal_irpp chom_irpp  pension_irpp nonsal_irpp nonsalexo_irpp nonsal defnonsal_irpp frais_prof {
						* revenus des pac individualiss
							* On attribue au pac de plus de 20 ans les revenus des PAC de moins de 20 ans quand il y a  des pac de moins de 20 ans et de plus de 20 ans
								replace `var'=`var'_pac/(npac-npac_m20)  if pac==1 & (npac-npac_m20)>0 & age >=20			
							* On attribue au membre de couple les revenus des PAC de moins de 20 ans quand il n'y a que des pac de moins de 20 ans ou que la date de naissance du pac n'est pas report
								replace `var'=`var'+`var'_pac/ndecl  if idnum==1  & ((npac>0 & npac_m20==npac) | (sal_irpp_pac+chom_irpp_pac+pension_irpp_pac+nonsal_pac+defnonsal_irpp_pac >0 & npac==0))
								replace `var'_conj=`var'_conj  +`var'_pac/ndecl  if conj==1  & ((npac>0 & npac_m20==npac) | (sal_irpp_pac+chom_irpp_pac+pension_irpp_pac+nonsal_pac+defnonsal_irpp_pac >0 & npac==0))
						*  revenus du conjoint
							gen temp=`var'
							replace `var'=`var'_conj  if conj==1
							replace `var'_conj=temp  if conj==1
							drop temp
					}
					drop *_conj *_pac
					
								
				
			* Reajustement
				* On garde seulement les plus de 20 ans
					drop if pac==1 & age<20
					drop ntot npac_m20 npac  anaispac_*
			* Nouvel Identifiant apres avoir dropp pac <20
				sort idfoy idnum
				drop idindiv idnum
				gen a=1
				bys idfoy: gen idnum=sum(a)
				gen idindiv=sum(a)
				bys idfoy : egen npac=sum(pac)
				bys idfoy : egen ntot=sum(a)
				drop a	
				
				
			* Conversion en euros
				if ${year}<2001 {
					ds year idfoy idnum idindiv pondn ndecl age agec mat sexe pac npac conj ntot , not
					foreach var of varlist `r(varlist)' {
						replace `var'=`var'/6.55957
					}
				}
				
			#delimit;
				order year idfoy idnum idindiv  pondn ntot ndecl  npac pac conj  age agec mat  
				salchom* sal* chom* pens* rente* nonsal* nonsal_irpp* defnonsal_irpp* nonsalexo_irpp* rfon* 
				rfin_irpp_foy rfin_bar_irpp_foy rfin_pl_irpp_foy rfin_int_irpp_foy* rfin_int_bar_irpp_foy* rfin_int_pl_irpp_foy rfin_div_irpp_foy* rfin_div_bar_irpp_foy* rfin_div_pl_irpp_foy rfin_av_irpp_foy rfin_av_bar_irpp_foy rfin_av_pl_irpp_foy 
				rfin_pv_irpp_foy rfin_pv_pro_irpp_foy rfin_pv_fon_irpp_foy rfin_pv_fin_irpp_foy rfin_pv_options_foy rfin_mv_irpp_foy rfin_mv_pro_irpp_foy  rfin_mv_fin_irpp_foy ;
				 #delimit cr
			
			*if `loop'==1 {
				save "$wfrev/rev${year}.dta",replace
			/*}
			if `loop'==2 {
				save "$wfrev/rev${year}avtretraitement.dta",replace
			}
}*/
}
macro drop taux*
/*
* Verification de l'individualisation
foreach var of varlist 	sal_irpp chom_irpp  pension_irpp nonsal_irpp nonsalexo_irpp nonsal defnonsal_irpp {
	bys idfoy : egen verif`var'=sum(`var')
	replace verif`var'=verif`var'-`var'_foy
	sum verif`var'
		
}
*/
