********************************************************************************************************************************
* Console for computing and exporting long-term series of wealth distribution (1800-1970) derived from inheritance tabulations *  
*********************************************************************************************************************************

set more off
clear

macro drop _all

* I) Determination of the different paths
*******************************************	
	
	* Project directory
		* John
			global projdir "C:/Users/John/Dropbox/WIDFrance/Papers/GGP2016Wealth/GGP2016WealthAppendixC"
		* Bertrand
			*global projdir "C:/Users/G839276/Dropbox/Dropbox/WIDFrance/Papers/GGP2016Wealth/GGP2016WealthAppendixC"
		
		* DataFiles Directory
			global projdirfiles "$projdir/DataFiles"
		* Directory SimulationGpinter		
			global projsimul "$projdirfiles/SimulationGpinter/rawdata"
			global projsimulres "$projdirfiles/SimulationGpinter/output"
		


* II) Simulation of long-term series of wealth distribution 
************************************************************
	
	* Data formatting 
		do "$projsimul/do_input_format_gpinter.do"
	* Use the application wid/gpinter
	* Exportation of the results
		do "$projdir/do_gperc_wealth.do"
	
