********************************************************************************************************
* Console for computing and exporting results on wealth distributions derived from the wealth surveys  *
********************************************************************************************************



set more off
clear

* I) Determination of the different paths
*******************************************
	
	 * Project directory
		* PSE  
			*global projdir "U:/these/Projet wealth_income"	
		* My laptop 
			global projdir "C:/Users/John/Desktop/these/Projet wealth_income"
		* Acces serveur PSE
			*global projdir "/home/j.goupille/U/these/Projet wealth_income"		
		* Acces CASD
			*global projdir "P:\W2IDF"
		
	* Appendix F: Wealth surveys
		global patdir "$projdir/GGP2016WealthAppendixF"
		* DoFiles
			global doresultspat "$patdir/DataFiles/DoFiles"
		* Rawdata
			global datapat "$patdir/DataFiles/RawData"
		* Working Files
			global wfpat "$patdir/DataFiles/WorkingFiles"
		
	

* II) Wealth surveys   
***********************

	* 1) Homogeneization of wealth surveys at the household and individual level: 1986, 1992, 1998, 2004, 2010
			do "$doresultspat/doEP86.do"
			do "$doresultspat/doEP92.do"
			do "$doresultspat/doEP98.do"
			do "$doresultspat/doEP04.do"
			do "$doresultspat/doEP10.do"
	* 2) Statistic descriptive on wealth surveys and adjustment to national accounts (by asset or by asset and asset-specific groups) 
			* Results are stored in the Excel File GGP2016WealthAppendixF
			do "$doresultspat/doEPresults.do"
			

